VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "TEMPer Gold Readings"
   ClientHeight    =   5205
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   7830
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5205
   ScaleWidth      =   7830
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdClearLog 
      Caption         =   "Clear Log"
      Height          =   495
      Left            =   6180
      TabIndex        =   9
      Top             =   120
      Width           =   1515
   End
   Begin VB.ComboBox cboCalibration 
      Enabled         =   0   'False
      Height          =   330
      ItemData        =   "Form1.frx":0000
      Left            =   3480
      List            =   "Form1.frx":0034
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   660
      Width           =   855
   End
   Begin VB.CommandButton cmdSet 
      Caption         =   "Set Calibration"
      Enabled         =   0   'False
      Height          =   495
      Left            =   1800
      TabIndex        =   3
      Top             =   720
      Width           =   1515
   End
   Begin VB.CommandButton cmdGet 
      Caption         =   "Get Calibration"
      Enabled         =   0   'False
      Height          =   495
      Left            =   1800
      TabIndex        =   2
      Top             =   120
      Width           =   1515
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop Sampling"
      Enabled         =   0   'False
      Height          =   495
      Left            =   4500
      TabIndex        =   6
      Top             =   720
      Width           =   1515
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start Sampling"
      Enabled         =   0   'False
      Height          =   495
      Left            =   4500
      TabIndex        =   5
      Top             =   120
      Width           =   1515
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close Device"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   1515
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "Open Device"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1515
   End
   Begin VB.Timer tmrSample 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   2880
      Top             =   1680
   End
   Begin VB.TextBox txtLog 
      Height          =   3855
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   7
      TabStop         =   0   'False
      Top             =   1320
      Width           =   6135
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Calibration"
      Height          =   255
      Left            =   3420
      TabIndex        =   8
      Top             =   360
      Width           =   975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'
'This is a small demo that uses the TEMPerGold class.
'
Private TG As TEMPerGold
Private SampleNum As Long

Private Sub Log(Optional ByVal Text As String)
    With txtLog
        .SelStart = &H7FFF
        .SelText = Text
    End With
End Sub

Private Sub LogLine(Optional ByVal Text As String)
    If Len(Text) > 0 Then Log Text
    Log vbNewLine
End Sub

Private Function PassFail(ByVal Result As Boolean) As String
    PassFail = IIf(Result, "Success", "Failure")
End Function

Private Sub cmdClearLog_Click()
    txtLog.Text = ""
End Sub

Private Sub cmdClose_Click()
    Dim Result As Boolean

    With TG
        Result = .CloseTEMPer(0)
        Log "Close(0): " & PassFail(Result)
        If Result Then
            LogLine
            If tmrSample.Enabled Then cmdStop_Click
            cmdOpen.Enabled = True
            cmdClose.Enabled = False
            cmdStart.Enabled = False
            cmdGet.Enabled = False
            cmdSet.Enabled = False
            cboCalibration.Enabled = False
        Else
            LogLine ", " & .Error
        End If
    End With
End Sub

Private Sub cmdGet_Click()
    Dim Result As Boolean
    Dim Calibration As Integer

    With TG
        Result = .GetCalibrationCelsius(0, Calibration)
        Log "Get Calibration: " & PassFail(Result)
        If Result Then
            LogLine ", " & CStr(Calibration) & "C"
            cboCalibration.ListIndex = Calibration + 8
        Else
            LogLine ", " & .Error
        End If
    End With
End Sub

Private Sub cmdOpen_Click()
    Dim Result As Boolean
    Dim Version As String
    
    With TG
        Result = .OpenTEMPer(0)
        Log "Open(0): " & PassFail(Result)
        If Result Then
            LogLine
            Result = .GetVersion(0, Version)
            Log "Get Version(0): " & PassFail(Result)
            If Result Then
                LogLine ", """ & Version & """"
                cmdOpen.Enabled = False
                cmdClose.Enabled = True
                cmdStart.Enabled = True
                cmdGet.Enabled = True
                cmdSet.Enabled = True
                cboCalibration.Enabled = True
                SampleNum = 0
            Else
                LogLine ", " & .Error
            End If
        Else
            LogLine ", " & .Error
        End If
    End With
End Sub

Private Sub cmdSet_Click()
    Dim Result As Boolean
    Dim Calibration As Integer

    Calibration = cboCalibration.ListIndex - 8
    With TG
        Result = .SetCalibrationCelsius(0, Calibration)
        Log "Set Calibration " & CStr(Calibration) & "C: " & PassFail(Result)
        If Result Then
            LogLine ", " & CStr(Calibration) & "C"
        Else
            LogLine ", " & .Error
        End If
    End With
End Sub

Private Sub cmdStart_Click()
    cmdStart.Enabled = False
    cmdStop.Enabled = True
    cmdGet.Enabled = False
    cmdSet.Enabled = False
    cboCalibration.Enabled = False
    LogLine "Sampling started."
    tmrSample.Enabled = True
End Sub

Private Sub cmdStop_Click()
    tmrSample.Enabled = False
    cmdStart.Enabled = True
    cmdStop.Enabled = False
    cmdGet.Enabled = True
    cmdSet.Enabled = True
    cboCalibration.Enabled = True
    LogLine "Sampling stopped."
End Sub

Private Sub Form_Load()
    Dim Result As Boolean
    
    Set TG = New TEMPerGold
    Result = TG.Initialize()
    Log "Initialize: " & PassFail(Result)
    If Result Then
        LogLine
        If TG.Count > 0 Then
            tmrSample.Interval = 1000
            LogLine "Sample Interval: " & CStr(tmrSample.Interval)
        Else
            LogLine "No TEMPer Gold devices found!"
            cmdOpen.Enabled = False
        End If
    Else
        LogLine ", " & TG.Error
        cmdOpen.Enabled = False
    End If
End Sub

Private Sub Form_Resize()
    If WindowState <> vbMinimized Then
        txtLog.Move 0, txtLog.Top, ScaleWidth, ScaleHeight - txtLog.Top
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    TG.CloseTEMPers
End Sub

Private Sub tmrSample_Timer()
    Dim Result As Boolean
    Dim Celsius As Single
    
    With TG
        Result = .GetCelsius(0, Celsius)
        'Discard our 1st sample (0) without displaying it, it will almost always be bad.
        'The device doesn't seem to "settle" until after a temperature fetch or two, the
        'open probably resets it.
        If SampleNum > 0 Then
            Log "Sample " & CStr(SampleNum) & " " & Format$(Time(), "Hh:Nn:Ss") _
              & " Read(0): " & PassFail(Result)
            If Result Then
                LogLine ", " & Format$(Celsius, "0.0#C\, ") & Format$(.CtoF(Celsius), "0.0#F ")
            Else
                LogLine ", " & .Error
                cmdStop_Click
            End If
        End If
    End With
    SampleNum = SampleNum + 1
End Sub
